﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private broker As MqttBroker
	Private client As MqttClient
	Private const port As Int = 8201
	Private serializator As B4XSerializator
	Public connected As Boolean
	Private brokerStarted As Boolean
	Private users As List
	Public isServer As Boolean
	Private currentName As String
	Private conv1 As ByteConverter
	Public server As ServerSocket
	Public Zone As String=""
	Public SetTempMax As Double=0
	Public SetTempMin As Double=0
	Public SetupDeviceList As List
	Public ListStatusDevice As List
	Public ListActionDevice As List
	Public HeaterSetup As Map
	Private NbDevice As Int= 0
	Type Message (Body As String, From As String)
	Public SetManueltemp As List 
		
	Private ControlAgent As Timer
	Private ServerLife As Boolean=False
End Sub

Sub Service_Create
	broker.Initialize("", port)
	broker.DebugLog = False
	users.Initialize
	SetupDeviceList.Initialize
	ListStatusDevice.Initialize
	ListActionDevice.Initialize
	HeaterSetup.Initialize
	SetManueltemp.Initialize
	
	ControlAgent.Initialize("ControlAgent",45000)
	ControlAgent.Enabled=True
	
	'******************** Charge le fichier Setup Device  **************
		
	If File.Exists(File.DirDefaultExternal, "SmsG-Setup.json") Then
		wait for (JsonFileAction.Read_JSONfile("SmsG-Setup.json")) complete  (DataList As List)
	End If
	SetupDeviceList=DataList
	
	
	
End Sub

' ***************Watchdog****************
Sub ControlAgent_Tick
	
	' Controle l'état du serveur toutes les 30s + controle la vie des devices

	
	'NbDevice=2
	If ListStatusDevice.Size<>NbDevice  Then
		Log("Manque des devices")
		
		Dim MapDataDevice As Map
		Private InfoStatusDevice() As String
		For Each L_Map As Map In SetupDeviceList 'Enumere la liste attendue et envoie une alerte pour les devices manquants.
			
			MapDataDevice= L_Map.Get(L_Map.GetKeyAt(0))
			For d1=1 To MapDataDevice.Get("NumberOfDevice")
					
				Private Device As String = ""
				Private SensorIntegred As Int=0
				Private Local As String= MapDataDevice.get("Localisation")
				Private DeviceInfo() As String=Regex.Split("/",MapDataDevice.Get("DeviceMacAddress " & d1))
				Private FindDevice As Boolean=False
				
				If DeviceInfo(0).StartsWith("*") Then 'Device avec une sonde de température
					Device=DeviceInfo(0).SubString(1) 'Supprime "*"
					SensorIntegred=1
				Else
					Device=DeviceInfo(0)
					SensorIntegred=0
				End If
				
				If ListStatusDevice.Size=0 Then
					InfoStatusDevice= Array As String("",Device,"off",True,Local,SensorIntegred)
					CallSubDelayed2(B4XPages.MainPage,"PanelInfo",InfoStatusDevice)
				Else
					For Each Event As String In ListStatusDevice
						Private Events() As String = Regex.Split(";",Event)
						If Device=Events(1) Then
							FindDevice=True
							'InfoStatusDevice= Array As String("",Device,"off",True,Local,SensorIntegred)
							'InfoStatusDevice= Array As String(Events(3).SubString(1),Events(1),Events(2),False,Events(0),Events(4))
							'CallSubDelayed2(B4XPages.MainPage,"PanelInfo",InfoStatusDevice)
							Exit
						End If
						
					Next
				End If
				
				If FindDevice=False And ListStatusDevice.Size<>0 Then
					InfoStatusDevice= Array As String("",Device,"off",True,Local,SensorIntegred)
					CallSubDelayed2(B4XPages.MainPage,"PanelInfo",InfoStatusDevice)
				End If
			Next
		Next
		
		If ListStatusDevice.Size>NbDevice Then 
			ListStatusDevice.Clear
		End If
		
	End If
	
	
	For Each Event As String In ListStatusDevice ' Analyse si le device ne répond plus
		Private Events() As String = Regex.Split(";",Event)
		
		If Events(Events.Length-1)=0 Then
			Private DataDevice As String= Events(0) & ";" & Events(1) & ";" & Events(2)  & ";" &  Events(3) & ";" &  Events(4) & ";" & "-1" 'Passe l'event à -1 s'il est resté à zéro depuis le dernier contrôle
			ListStatusDevice.Set(ListStatusDevice.IndexOf(Event),DataDevice)
			Log(Events(1) & " Ne répond pas")
			
			Private InfoStatusDevice() As String
			InfoStatusDevice= Array As String("",Events(1),"off",True,Events(0),Events(4))
			CallSubDelayed2(B4XPages.MainPage,"PanelInfo",InfoStatusDevice)
			
		Else if Events(Events.Length-1)=1 Then
			Private DataDevice As String= Events(0) & ";" & Events(1) & ";" & Events(2)  & ";" & Events(3) & ";" &  Events(4) & ";" & "0"
			ListStatusDevice.Set(ListStatusDevice.IndexOf(Event),DataDevice)
			Private InfoStatusDevice() As String
			
			If Events(3)="-" Then
				InfoStatusDevice= Array As String(Events(3),Events(1),Events(2),False,Events(0),Events(4))
			Else
				InfoStatusDevice= Array As String(Events(3).SubString(1),Events(1),Events(2),False,Events(0),Events(4))
			End If
			
			CallSubDelayed2(B4XPages.MainPage,"PanelInfo",InfoStatusDevice)
		Else
			Private InfoStatusDevice() As String
			InfoStatusDevice= Array As String("",Events(1),"off",True,Events(0),Events(4))
			CallSubDelayed2(B4XPages.MainPage,"PanelInfo",InfoStatusDevice)
			Log(Events(1) & " Ne répond pas")
		End If
	Next
	
	
	If ServerLife=False Then
		Log("Alerte serveur bloqué!")
		StopService(SchedulerAgent)
		
		Try
			'connected=False
			'brokerStarted = False
			client.Close
			'broker.Stop
			
		Catch
			Log(LastException)
		End Try
				
		StopService(Me)
	End If
	
	ServerLife=False
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	
	ConnectTo( "127.0.0.1","Server")
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Public Sub ConnectTo(Host As String, Name As String)
	Log("Connexion du server MQTT en cours")
	currentName = Name
	isServer = Host = "127.0.0.1"
	If isServer Then
		
		If brokerStarted = False Then
			broker.DebugLog=False
			broker.SetUserAndPassword("Admin","media")
			broker.Start
			
			brokerStarted = True
		End If
		users.Clear
		Host = "127.0.0.1"
	End If
	Log("IP Server : " & server.GetMyIP)
	If connected Then client.Close
	
	Try
		client.Initialize("client", $"tcp://${Host}:${port}"$, "android" & Rnd(1, 10000000))
		Dim mo As MqttConnectOptions
		mo.Initialize("Admin", "media")
		'this message will be sent if the client is disconnected unexpectedly.
		mo.SetLastWill("all/disconnect", serializator.ConvertObjectToBytes(currentName), 1, False)
		client.Connect2(mo)
	Catch
		Log(LastException)
	End Try
	'Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Private Sub client_Connected (Success As Boolean)
	Log($"Connected: ${Success}"$)
	
	Try
		If Success Then
			connected = True
			'client.Subscribe("shellies/shelly1-C45BBE5F4C0B/info", 0)
			client.Subscribe("all/#", 0)
				
			'********** Publication du Host et du nom*******
		
			client.Publish2("all/connect", serializator.ConvertObjectToBytes(currentName), 0, False)
		
			'************ Souscription aux differents devices configurés **********
				
			Dim MapDataDevice As Map
			For Each L_Map As Map In SetupDeviceList
			
				MapDataDevice= L_Map.Get(L_Map.GetKeyAt(0))
				For d1=1 To MapDataDevice.Get("NumberOfDevice")
					
					Private Device As String = ""
					Private DeviceInfo() As String=Regex.Split("/",MapDataDevice.Get("DeviceMacAddress " & d1))
				
					If DeviceInfo(0).StartsWith("*") Then 'Device avec une sonde de température
						Device=DeviceInfo(0).SubString(1) 'Supprime "*"
					Else
						Device=DeviceInfo(0)
					End If
					
					client.Subscribe("shellies/" & Device & "/#", 0)
				Next
			Next
		
	
			' ************ Lancement du SchedulerAgent *************
			StartService(SchedulerAgent)
		Else
			ToastMessageShow("Error connecting: " & LastException, True)
		End If
	Catch
		Log(LastException)
	End Try
	
End Sub

Private Sub client_MessageArrived (Topic As String, Payload() As Byte)
	
	Private Status As String =conv1.StringFromBytes(Payload,"UTF8")
	'Dim receivedObject As Object  = serializator.ConvertBytesToObject(Payload)
	'Log(Topic & " :" & Status)
	
	
	Private MapDataDevice As Map
	Private FindDevice As Boolean=False
	Private Idsensor As String =""
	
	If  Topic.Contains("command")=False Then
		ServerLife=True
		NbDevice=0
		For Each L_Map As Map In SetupDeviceList
			
			MapDataDevice= L_Map.Get(L_Map.GetKeyAt(0))
			NbDevice= NbDevice + MapDataDevice.Get("NumberOfDevice")
			For d1=1 To MapDataDevice.Get("NumberOfDevice")
				Private Device As String = ""
				Private DeviceInfo() As String=Regex.Split("/",MapDataDevice.Get("DeviceMacAddress " & d1))
				
				Device=DeviceInfo(0)
				
				If DeviceInfo.Length=2 Then 'Identifie si le device est dépendant d'un deice avec sonde de Température
					Idsensor= DeviceInfo(1)
				Else
					Idsensor="-"
				End If
				
				If Device.StartsWith("*") Then 'Device avec une sonde de température
					Device=Device.SubString(1) 'Supprime "*"
				End If
				
				If Topic.Contains("shellies/" & Device & "/relay/") Then
					Log(MapDataDevice.Get("Localisation") & ": " & Device & " : Status = " & Status)
					
					For Each value As String In ListStatusDevice
						If value.Contains(MapDataDevice.Get("Localisation") & ";" & Device) Then 'Mise à jour des status dans une liste
							Private detail() As String = Regex.Split(";",ListStatusDevice.Get(ListStatusDevice.IndexOf(value)))
							
							If detail(3).Contains("shelly1") Or Idsensor<>"-" Then 'Détecte que le device est rattaché à une sonde d'un autre device
								
								For Each values As String In ListStatusDevice 
									Private value1() As String = Regex.Split(";",values)
									If Idsensor = value1(1) Then 'Recherche le device
										detail(3)=value1(3) 'Récupère la température
									End If
								Next
								
							End If
							If DeviceInfo(0).StartsWith("*") Then
								ListStatusDevice.Set(ListStatusDevice.IndexOf(value),MapDataDevice.Get("Localisation") & ";" & Device & ";" & Status & ";" & detail(3) & ";" & 1 & ";" & 1)
							Else
								ListStatusDevice.Set(ListStatusDevice.IndexOf(value),MapDataDevice.Get("Localisation") & ";" & Device & ";" & Status & ";" & detail(3) & ";" & 0 & ";" & 1)
							End If
						
						FindDevice=True
						Exit
						End If
					Next
					
					If FindDevice=False  Then 'Creation de la liste
						If DeviceInfo(0).StartsWith("*") Then
							ListStatusDevice.add(MapDataDevice.Get("Localisation") & ";" & Device & ";" & Status & ";" & Idsensor & ";" & 1 & ";" & 1)
						Else
							ListStatusDevice.add(MapDataDevice.Get("Localisation") & ";" & Device & ";" & Status & ";" & Idsensor & ";" & 0 & ";" & 1)
						End If
						
					End If
					
				Else if Topic.Contains("shellies/" & Device & "/ext_temperature/0") Then 'Extraction température
					Log(MapDataDevice.Get("Localisation") & ": " & Device & " Température " & Status)
					
					For Each value As String In ListStatusDevice
						If value.Contains(MapDataDevice.Get("Localisation") & ";" & Device) Then 'Mise à jour des status dans une liste
							Private detail() As String = Regex.Split(";",ListStatusDevice.Get(ListStatusDevice.IndexOf(value)))
							If DeviceInfo(0).StartsWith("*") Then
								ListStatusDevice.Set(ListStatusDevice.IndexOf(value),MapDataDevice.Get("Localisation") & ";" & Device & ";" & detail(2) & ";" & Status & ";" & 1 & ";" & 1)
							Else
								ListStatusDevice.Set(ListStatusDevice.IndexOf(value),MapDataDevice.Get("Localisation") & ";" & Device & ";" & detail(2) & ";" & Status & ";" & 0 & ";" & 1)
							End If
							
							FindDevice=True
							Exit
						End If
					Next
					
				End If
			Next
		Next
	End If
		
		
	Try
		If Topic = "all/connect" Or Topic = "all/disconnect" Then
			Dim receivedObject As Object  = serializator.ConvertBytesToObject(Payload)
			'new client has connected or disconnected
			Dim newUser As String = receivedObject
			If isServer Then
				Log($"${Topic}: ${newUser}"$)
				Dim index As Int = users.IndexOf(newUser)
				If Topic.EndsWith("connect") And index = -1 Then users.Add(newUser)
				If Topic.EndsWith("disconnect") And index >= 0 Then users.RemoveAt(index)
				client.Publish2("all/users", serializator.ConvertObjectToBytes(users), 0, False)
			End If
		Else if Topic = "all/users" Then
			Dim receivedObject As Object  = serializator.ConvertBytesToObject(Payload)
			Dim newUsers As List = receivedObject
			'CallSubDelayed2(Chat, "NewUsers", newUsers) 'this will start the chat activity if it wasn't started yet.
		Else
			'Dim m As Message = receivedObject
			'CallSub2(Chat, "NewMessage1", test)
		End If
	Catch
		Log(LastException)
		'StopService(Me)
	End Try
	
	
		
End Sub

Public Sub SendMessage(DeviceIdCde As String,Body As String)
	
	Try
		If connected Then
			'client.Subscribe("shellies/shelly1-C45BBE/#", 0)
			
			Log(DeviceIdCde & "  ------  " & Body)
			client.Publish2(DeviceIdCde, CreateMessage(Body), 0, False)
			'connected=False
			'client.Close
			
		End If
	Catch
		Log(LastException)
		'connected=False
		client.Close
		'broker.Stop
		StopService(Me)
	End Try
	
End Sub

Public Sub Disconnect
	If connected Then client.Close
End Sub

Private Sub CreateMessage(Body As String) As Byte()
	Dim m As Message
	
	m.Initialize
	m.Body = Body
	m.From = currentName
	Return conv1.StringToBytes(Body,"UTF8")
	'Return serializator.ConvertObjectToBytes(m)
End Sub

Private Sub client_Disconnected
	connected = False
''	If IsPaused(Chat) = False Then
''		CallSub(Chat, "Disconnected")
''	End If
	If isServer Then
		broker.Stop
		brokerStarted = False
	End If
End Sub


Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	StartServiceAt(Me,DateTime.Now + 2000,True) ' Relance après 2s si service arrêté
End Sub

